Index: fs/fat/misc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/fat/misc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/fat/misc.c	22 Jul 2004 19:48:48 -0000	1.1
+++ fs/fat/misc.c	4 Aug 2004 01:33:30 -0000	1.2
@@ -108,6 +108,7 @@
 		return;
 	}
 	fsinfo->free_clusters = CF_LE_L(MSDOS_SB(sb)->free_clusters);
+	fsinfo->next_cluster = CF_LE_L(MSDOS_SB(sb)->prev_free);
 	fat_mark_buffer_dirty(sb, bh);
 	fat_brelse(sb, bh);
 }
@@ -315,11 +316,12 @@
  */
 
 int fat__get_entry(struct inode *dir, loff_t *pos,struct buffer_head **bh,
-    struct msdos_dir_entry **de, int *ino)
+		   struct msdos_dir_entry **de, loff_t *i_pos)
 {
 	struct super_block *sb = dir->i_sb;
 	struct msdos_sb_info *sbi = MSDOS_SB(sb);
-	int sector, offset;
+	int sector;
+	loff_t offset;
 
 	while (1) {
 		offset = *pos;
@@ -342,7 +344,7 @@
 
 		offset &= sb->s_blocksize - 1;
 		*de = (struct msdos_dir_entry *) ((*bh)->b_data + offset);
-		*ino = (sector << sbi->dir_per_block_bits) + (offset >> MSDOS_DIR_BITS);
+		*i_pos = ((loff_t)sector << sbi->dir_per_block_bits) + (offset >> MSDOS_DIR_BITS);
 
 		return 0;
 	}
@@ -382,7 +384,7 @@
     done = !IS_FREE(data[entry].name) \
       && ( \
            ( \
-             (MSDOS_SB(sb)->fat_bits != 32) ? 0 : (CF_LE_W(data[entry].starthi) << 16) \
+             (sbi->fat_bits != 32) ? 0 : (CF_LE_W(data[entry].starthi) << 16) \
            ) \
            | CF_LE_W(data[entry].start) \
          ) == *number;
@@ -399,35 +401,38 @@
 	    (*number)++; \
     }
 
-static int raw_scan_sector(struct super_block *sb,int sector,const char *name,
-    int *number,int *ino,struct buffer_head **res_bh,
-    struct msdos_dir_entry **res_de)
+static int raw_scan_sector(struct super_block *sb, int sector,
+			   const char *name, int *number, loff_t *i_pos,
+			   struct buffer_head **res_bh,
+			   struct msdos_dir_entry **res_de)
 {
+	struct msdos_sb_info *sbi = MSDOS_SB(sb);
 	struct buffer_head *bh;
 	struct msdos_dir_entry *data;
 	int entry,start,done;
 
-	if (!(bh = fat_bread(sb,sector)))
+	if (!(bh = fat_bread(sb, sector)))
 		return -EIO;
 	data = (struct msdos_dir_entry *) bh->b_data;
-	for (entry = 0; entry < MSDOS_SB(sb)->dir_per_block; entry++) {
+	for (entry = 0; entry < sbi->dir_per_block; entry++) {
 /* RSS_COUNT:  if (data[entry].name == name) done=true else done=false. */
 		if (name) {
 			RSS_NAME
 		} else {
-			if (!ino) RSS_COUNT
+			if (!i_pos) RSS_COUNT
 			else {
 				if (number) RSS_START
 				else RSS_FREE
 			}
 		}
 		if (done) {
-			if (ino)
-				*ino = sector * MSDOS_SB(sb)->dir_per_block + entry;
+			if (i_pos) {
+				*i_pos = ((loff_t)sector << sbi->dir_per_block_bits) + entry;
+			}
 			start = CF_LE_W(data[entry].start);
-			if (MSDOS_SB(sb)->fat_bits == 32) {
+			if (sbi->fat_bits == 32)
 				start |= (CF_LE_W(data[entry].starthi) << 16);
-			}
+
 			if (!res_bh)
 				fat_brelse(sb, bh);
 			else {
@@ -447,16 +452,19 @@
  * requested entry is found or the end of the directory is reached.
  */
 
-static int raw_scan_root(struct super_block *sb,const char *name,int *number,int *ino,
-    struct buffer_head **res_bh,struct msdos_dir_entry **res_de)
+static int raw_scan_root(struct super_block *sb, const char *name,
+			 int *number, loff_t *i_pos,
+			 struct buffer_head **res_bh,
+			 struct msdos_dir_entry **res_de)
 {
 	int count,cluster;
 
 	for (count = 0;
 	     count < MSDOS_SB(sb)->dir_entries / MSDOS_SB(sb)->dir_per_block;
 	     count++) {
-		if ((cluster = raw_scan_sector(sb,MSDOS_SB(sb)->dir_start+count,
-					       name,number,ino,res_bh,res_de)) >= 0)
+		cluster = raw_scan_sector(sb, MSDOS_SB(sb)->dir_start + count,
+					  name, number, i_pos, res_bh, res_de);
+		if (cluster >= 0)
 			return cluster;
 	}
 	return -ENOENT;
@@ -468,20 +476,24 @@
  * requested entry is found or the end of the directory is reached.
  */
 
-static int raw_scan_nonroot(struct super_block *sb,int start,const char *name,
-    int *number,int *ino,struct buffer_head **res_bh,struct msdos_dir_entry
-    **res_de)
+static int raw_scan_nonroot(struct super_block *sb, int start, const char *name,
+			    int *number, loff_t *i_pos,
+			    struct buffer_head **res_bh,
+			    struct msdos_dir_entry **res_de)
 {
-	int count,cluster;
+	struct msdos_sb_info *sbi = MSDOS_SB(sb);
+	int count, cluster, sector;
 
 #ifdef DEBUG
 	printk("raw_scan_nonroot: start=%d\n",start);
 #endif
 	do {
-		for (count = 0; count < MSDOS_SB(sb)->cluster_size; count++) {
-			if ((cluster = raw_scan_sector(sb,(start-2)*
-			    MSDOS_SB(sb)->cluster_size+MSDOS_SB(sb)->data_start+
-			    count,name,number,ino,res_bh,res_de)) >= 0)
+		for (count = 0; count < sbi->cluster_size; count++) {
+			sector = (start - 2) * sbi->cluster_size
+				+ count + sbi->data_start;
+			cluster = raw_scan_sector(sb, sector, name, number,
+						  i_pos, res_bh, res_de);
+			if (cluster >= 0)
 				return cluster;
 		}
 		if (!(start = fat_access(sb,start,-1))) {
@@ -505,13 +517,13 @@
  */
 
 static int raw_scan(struct super_block *sb, int start, const char *name,
-    int *number, int *ino, struct buffer_head **res_bh,
-    struct msdos_dir_entry **res_de)
+		    loff_t *i_pos, struct buffer_head **res_bh,
+		    struct msdos_dir_entry **res_de)
 {
 	if (start)
-		return raw_scan_nonroot(sb,start,name,number,ino,res_bh,res_de);
+		return raw_scan_nonroot(sb,start,name,NULL,i_pos,res_bh,res_de);
 	else
-		return raw_scan_root(sb,name,number,ino,res_bh,res_de);
+		return raw_scan_root(sb,name,NULL,i_pos,res_bh,res_de);
 }
 
 /*
@@ -520,19 +532,21 @@
  */
 int fat_subdirs(struct inode *dir)
 {
-	int count;
+	struct msdos_sb_info *sbi = MSDOS_SB(dir->i_sb);
+	int number;
 
-	count = 0;
-	if ((dir->i_ino == MSDOS_ROOT_INO) &&
-	    (MSDOS_SB(dir->i_sb)->fat_bits != 32)) {
-		(void) raw_scan_root(dir->i_sb,NULL,&count,NULL,NULL,NULL);
-	} else {
-		if ((dir->i_ino != MSDOS_ROOT_INO) &&
-		    !MSDOS_I(dir)->i_start) return 0; /* in mkdir */
-		else (void) raw_scan_nonroot(dir->i_sb,MSDOS_I(dir)->i_start,
-		    NULL,&count,NULL,NULL,NULL);
+	number = 0;
+	if ((dir->i_ino == MSDOS_ROOT_INO) && (sbi->fat_bits != 32))
+		raw_scan_root(dir->i_sb, NULL, &number, NULL, NULL, NULL);
+	else {
+		if ((dir->i_ino != MSDOS_ROOT_INO) && !MSDOS_I(dir)->i_start)
+			return 0; /* in mkdir */
+		else {
+			raw_scan_nonroot(dir->i_sb, MSDOS_I(dir)->i_start,
+					 NULL, &number, NULL, NULL, NULL);
+		}
 	}
-	return count;
+	return number;
 }
 
 
@@ -541,12 +555,12 @@
  * for an empty directory slot (name is NULL). Returns an error code or zero.
  */
 
-int fat_scan(struct inode *dir,const char *name,struct buffer_head **res_bh,
-    struct msdos_dir_entry **res_de,int *ino)
+int fat_scan(struct inode *dir, const char *name, struct buffer_head **res_bh,
+	     struct msdos_dir_entry **res_de, loff_t *i_pos)
 {
 	int res;
 
-	res = raw_scan(dir->i_sb,MSDOS_I(dir)->i_start,
-		       name, NULL, ino, res_bh, res_de);
-	return res<0 ? res : 0;
+	res = raw_scan(dir->i_sb, MSDOS_I(dir)->i_start, name, i_pos,
+		       res_bh, res_de);
+	return (res < 0) ? res : 0;
 }
Index: fs/freevxfs/vxfs.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs.h	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs.h	4 Aug 2004 01:33:30 -0000	1.2
@@ -30,7 +30,7 @@
 #ifndef _VXFS_SUPER_H_
 #define _VXFS_SUPER_H_
 
-#ident "$Id: vxfs.h,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs.h,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - superblock structure.
Index: fs/freevxfs/vxfs_bmap.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_bmap.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_bmap.c	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_bmap.c	4 Aug 2004 01:33:30 -0000	1.2
@@ -27,7 +27,7 @@
  * SUCH DAMAGE.
  */
 
-#ident "$Id: vxfs_bmap.c,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_bmap.c,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - filesystem to disk block mapping.
Index: fs/freevxfs/vxfs_dir.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_dir.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_dir.h	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_dir.h	4 Aug 2004 01:33:30 -0000	1.2
@@ -30,7 +30,7 @@
 #ifndef _VXFS_DIR_H_
 #define _VXFS_DIR_H_
 
-#ident "$Id: vxfs_dir.h,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_dir.h,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - directory structure.
Index: fs/freevxfs/vxfs_extern.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_extern.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_extern.h	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_extern.h	4 Aug 2004 01:33:30 -0000	1.2
@@ -30,7 +30,7 @@
 #ifndef _VXFS_EXTERN_H_
 #define _VXFS_EXTERN_H_
 
-#ident "$Id: vxfs_extern.h,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_extern.h,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - external prototypes.
Index: fs/freevxfs/vxfs_fshead.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_fshead.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_fshead.c	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_fshead.c	4 Aug 2004 01:33:30 -0000	1.2
@@ -27,7 +27,7 @@
  * SUCH DAMAGE.
  */
 
-#ident "$Id: vxfs_fshead.c,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_fshead.c,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - fileset header routines.
Index: fs/freevxfs/vxfs_fshead.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_fshead.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_fshead.h	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_fshead.h	4 Aug 2004 01:33:30 -0000	1.2
@@ -30,7 +30,7 @@
 #ifndef _VXFS_FSHEAD_H_
 #define _VXFS_FSHEAD_H_
 
-#ident "$Id: vxfs_fshead.h,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_fshead.h,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - fileset header structures.
Index: fs/freevxfs/vxfs_immed.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_immed.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_immed.c	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_immed.c	4 Aug 2004 01:33:30 -0000	1.2
@@ -27,7 +27,7 @@
  * SUCH DAMAGE.
  */
 
-#ident "$Id: vxfs_immed.c,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_immed.c,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - support for 'immed' inodes.
Index: fs/freevxfs/vxfs_inode.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_inode.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_inode.c	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_inode.c	4 Aug 2004 01:33:30 -0000	1.2
@@ -27,7 +27,7 @@
  * SUCH DAMAGE.
  */
 
-#ident "$Id: vxfs_inode.c,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_inode.c,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - inode routines.
Index: fs/freevxfs/vxfs_inode.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_inode.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_inode.h	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_inode.h	4 Aug 2004 01:33:30 -0000	1.2
@@ -30,7 +30,7 @@
 #ifndef _VXFS_INODE_H_
 #define _VXFS_INODE_H_
 
-#ident "$Id: vxfs_inode.h,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_inode.h,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - inode structure.
Index: fs/freevxfs/vxfs_lookup.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_lookup.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_lookup.c	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_lookup.c	4 Aug 2004 01:33:30 -0000	1.2
@@ -27,7 +27,7 @@
  * SUCH DAMAGE.
  */
 
-#ident "$Id: vxfs_lookup.c,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_lookup.c,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - lookup and other directory related code.
Index: fs/freevxfs/vxfs_olt.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_olt.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_olt.c	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_olt.c	4 Aug 2004 01:33:30 -0000	1.2
@@ -27,7 +27,7 @@
  * SUCH DAMAGE.
  */
 
-#ident "$Id: vxfs_olt.c,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_olt.c,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /* 
  * Veritas filesystem driver - object location table support.
Index: fs/freevxfs/vxfs_olt.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_olt.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_olt.h	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_olt.h	4 Aug 2004 01:33:30 -0000	1.2
@@ -30,7 +30,7 @@
 #ifndef _VXFS_OLT_H_
 #define _VXFS_OLT_H_
 
-#ident "$Id: vxfs_olt.h,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_olt.h,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - Object Location Table data structures.
Index: fs/freevxfs/vxfs_subr.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_subr.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_subr.c	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_subr.c	4 Aug 2004 01:33:30 -0000	1.2
@@ -27,7 +27,7 @@
  * SUCH DAMAGE.
  */
 
-#ident "$Id: vxfs_subr.c,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_subr.c,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - shared subroutines.
Index: fs/freevxfs/vxfs_super.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/freevxfs/vxfs_super.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/freevxfs/vxfs_super.c	22 Jul 2004 19:48:53 -0000	1.1
+++ fs/freevxfs/vxfs_super.c	4 Aug 2004 01:33:30 -0000	1.2
@@ -27,7 +27,7 @@
  * SUCH DAMAGE.
  */
 
-#ident "$Id: vxfs_super.c,v 1.1 2004/07/22 19:48:53 joff Exp $"
+#ident "$Id: vxfs_super.c,v 1.2 2004/08/04 01:33:30 joff Exp $"
 
 /*
  * Veritas filesystem driver - superblock related routines.
Index: fs/hfs/mdb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/hfs/mdb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/hfs/mdb.c	22 Jul 2004 19:48:48 -0000	1.1
+++ fs/hfs/mdb.c	4 Aug 2004 01:33:30 -0000	1.2
@@ -197,7 +197,7 @@
 
 	if (!(mdb->attrib & htons(HFS_SB_ATTRIB_CLEAN))) {
 		hfs_warn("hfs_fs: WARNING: mounting unclean filesystem.\n");
-	} else if (!readonly) {
+	} else if (!readonly && !(mdb->attrib & (HFS_SB_ATTRIB_HLOCK | HFS_SB_ATTRIB_SLOCK))) {
 		/* Mark the volume uncleanly unmounted in case we crash */
 		hfs_put_ns(mdb->attrib & htons(~HFS_SB_ATTRIB_CLEAN),
 			   raw->drAtrb);
Index: fs/hfs/super.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/hfs/super.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/hfs/super.c	22 Jul 2004 19:48:48 -0000	1.1
+++ fs/hfs/super.c	4 Aug 2004 01:33:30 -0000	1.2
@@ -49,6 +49,7 @@
 	put_super:	hfs_put_super,
 	write_super:	hfs_write_super,
 	statfs:		hfs_statfs,
+	remount_fs:     hfs_remount,
 };
 
 /*================ File-local variables ================*/
@@ -162,23 +163,24 @@
 	char *this_char, *value;
 	char names, fork;
 
-	/* initialize the sb with defaults */
-	memset(hsb, 0, sizeof(*hsb));
-	hsb->magic = HFS_SB_MAGIC;
-	hsb->s_uid   = current->uid;
-	hsb->s_gid   = current->gid;
-	hsb->s_umask = current->fs->umask;
-	hsb->s_type    = 0x3f3f3f3f;	/* == '????' */
-	hsb->s_creator = 0x3f3f3f3f;	/* == '????' */
-	hsb->s_lowercase = 0;
-	hsb->s_quiet     = 0;
-	hsb->s_afpd      = 0;
-        /* default version. 0 just selects the defaults */
-	hsb->s_version   = 0; 
-	hsb->s_conv = 'b';
-	names = '?';
-	fork = '?';
-	*part = 0;
+	if (hsb->magic != HFS_SB_MAGIC) {
+		/* initialize the sb with defaults */
+		hsb->magic = HFS_SB_MAGIC;
+		hsb->s_uid   = current->uid;
+		hsb->s_gid   = current->gid;
+		hsb->s_umask = current->fs->umask;
+		hsb->s_type    = 0x3f3f3f3f;	/* == '????' */
+		hsb->s_creator = 0x3f3f3f3f;	/* == '????' */
+		hsb->s_lowercase = 0;
+		hsb->s_quiet     = 0;
+		hsb->s_afpd      = 0;
+		/* default version. 0 just selects the defaults */
+		hsb->s_version   = 0; 
+		hsb->s_conv = 'b';
+		names = '?';
+		fork = '?';
+		*part = 0;
+	}
 
 	if (!options) {
 		goto done;
@@ -393,17 +395,24 @@
 	struct hfs_mdb *mdb;
 	struct hfs_cat_key key;
 	kdev_t dev = s->s_dev;
+	int dev_blocksize;
 	hfs_s32 part_size, part_start;
 	struct inode *root_inode;
 	int part;
 
+	memset(HFS_SB(s), 0, sizeof(*(HFS_SB(s))));	
 	if (!parse_options((char *)data, HFS_SB(s), &part)) {
 		hfs_warn("hfs_fs: unable to parse mount options.\n");
 		goto bail3;
 	}
 
 	/* set the device driver to 512-byte blocks */
-	set_blocksize(dev, HFS_SECTOR_SIZE);
+	if (set_blocksize(dev, HFS_SECTOR_SIZE) < 0) {
+		dev_blocksize = get_hardsect_size(dev);
+		hfs_warn("hfs_fs: unsupported device block size: %d\n",
+			 dev_blocksize);
+		goto bail3;
+	}
 	s->s_blocksize_bits = HFS_SECTOR_SIZE_BITS;
 	s->s_blocksize = HFS_SECTOR_SIZE;
 
@@ -480,6 +489,27 @@
 	return NULL;	
 }
 
+int hfs_remount(struct super_block *s, int *flags, char *data)
+{
+        int part; /* ignored */
+
+        if (!parse_options(data, HFS_SB(s), &part)) {
+                hfs_warn("hfs_fs: unable to parse mount options.\n");
+                return -EINVAL;
+	}
+
+        if ((*flags & MS_RDONLY) == (s->s_flags & MS_RDONLY))
+                return 0;
+	if (!(*flags & MS_RDONLY)) {
+                if (HFS_SB(s)->s_mdb->attrib & (HFS_SB_ATTRIB_HLOCK | HFS_SB_ATTRIB_SLOCK)) {
+                        hfs_warn("hfs_fs: Filesystem is marked locked, leaving it read-only.\n");
+		        s->s_flags |= MS_RDONLY;
+			*flags |= MS_RDONLY;
+	        }
+        }
+	return 0;
+}
+
 static int __init init_hfs_fs(void)
 {
         hfs_cat_init();
Index: fs/intermezzo/file.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/intermezzo/file.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/intermezzo/file.c	22 Jul 2004 19:48:50 -0000	1.1
+++ fs/intermezzo/file.c	4 Aug 2004 01:33:31 -0000	1.2
@@ -61,7 +61,7 @@
 
 static int presto_open_upcall(int minor, struct dentry *de)
 {
-        int rc;
+        int rc = 0;
         char *path, *buffer;
         struct presto_file_set *fset;
         int pathlen;
Index: fs/intermezzo/super.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/intermezzo/super.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/intermezzo/super.c	22 Jul 2004 19:48:50 -0000	1.1
+++ fs/intermezzo/super.c	4 Aug 2004 01:33:31 -0000	1.2
@@ -23,8 +23,8 @@
  *  presto's super.c
  */
 
-static char rcsid[] __attribute ((unused)) = "$Id: super.c,v 1.1 2004/07/22 19:48:50 joff Exp $";
-#define INTERMEZZO_VERSION "$Revision: 1.1 $"
+static char rcsid[] __attribute ((unused)) = "$Id: super.c,v 1.2 2004/08/04 01:33:31 joff Exp $";
+#define INTERMEZZO_VERSION "$Revision: 1.2 $"
 
 #include <stdarg.h>
 
Index: fs/isofs/rock.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/isofs/rock.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/isofs/rock.c	22 Jul 2004 19:48:52 -0000	1.1
+++ fs/isofs/rock.c	4 Aug 2004 01:33:31 -0000	1.2
@@ -14,6 +14,7 @@
 #include <linux/slab.h>
 #include <linux/pagemap.h>
 #include <linux/smp_lock.h>
+#include <asm/page.h>
 
 #include "rock.h"
 
@@ -419,7 +420,7 @@
   return 0;
 }
 
-static char *get_symlink_chunk(char *rpnt, struct rock_ridge *rr)
+static char *get_symlink_chunk(char *rpnt, struct rock_ridge *rr, char *plimit)
 {
 	int slen;
 	int rootflag;
@@ -431,16 +432,25 @@
 		rootflag = 0;
 		switch (slp->flags & ~1) {
 		case 0:
+			if (slp->len > plimit - rpnt)
+				return NULL;
 			memcpy(rpnt, slp->text, slp->len);
 			rpnt+=slp->len;
 			break;
+		case 2:
+			if (rpnt >= plimit)
+				return NULL;
+			*rpnt++='.';
+			break;
 		case 4:
+			if (2 > plimit - rpnt)
+				return NULL;
 			*rpnt++='.';
-			/* fallthru */
-		case 2:
 			*rpnt++='.';
 			break;
 		case 8:
+			if (rpnt >= plimit)
+				return NULL;
 			rootflag = 1;
 			*rpnt++='/';
 			break;
@@ -457,17 +467,23 @@
 			 * If there is another SL record, and this component
 			 * record isn't continued, then add a slash.
 			 */
-			if ((!rootflag) && (rr->u.SL.flags & 1) && !(oldslp->flags & 1))
+			if ((!rootflag) && (rr->u.SL.flags & 1) &&
+			    !(oldslp->flags & 1)) {
+				if (rpnt >= plimit)
+					return NULL;
 				*rpnt++='/';
+			}
 			break;
 		}
 
 		/*
 		 * If this component record isn't continued, then append a '/'.
 		 */
-		if (!rootflag && !(oldslp->flags & 1))
+		if (!rootflag && !(oldslp->flags & 1)) {
+			if (rpnt >= plimit)
+				return NULL;
 			*rpnt++='/';
-
+		}
 	}
 	return rpnt;
 }
@@ -548,7 +564,10 @@
 			CHECK_SP(goto out);
 			break;
 		case SIG('S', 'L'):
-			rpnt = get_symlink_chunk(rpnt, rr);
+			rpnt = get_symlink_chunk(rpnt, rr,
+						 link + (PAGE_SIZE - 1));
+			if (rpnt == NULL)
+				goto out;
 			break;
 		case SIG('C', 'E'):
 			/* This tells is if there is a continuation record */
Index: fs/jbd/commit.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/jbd/commit.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/jbd/commit.c	22 Jul 2004 19:48:48 -0000	1.1
+++ fs/jbd/commit.c	4 Aug 2004 01:33:31 -0000	1.2
@@ -19,6 +19,8 @@
 #include <linux/errno.h>
 #include <linux/slab.h>
 #include <linux/locks.h>
+#include <linux/mm.h>
+#include <linux/pagemap.h>
 #include <linux/smp_lock.h>
 
 extern spinlock_t journal_datalist_lock;
@@ -34,6 +36,49 @@
 }
 
 /*
+ * When an ext3-ordered file is truncated, it is possible that many pages are
+ * not sucessfully freed, because they are attached to a committing transaction.
+ * After the transaction commits, these pages are left on the LRU, with no
+ * ->mapping, and with attached buffers.  These pages are trivially reclaimable
+ * by the VM, but their apparent absence upsets the VM accounting, and it makes
+ * the numbers in /proc/meminfo look odd.
+ *
+ * So here, we have a buffer which has just come off the forget list.  Look to
+ * see if we can strip all buffers from the backing page.
+ *
+ * Called under lock_journal(), and possibly under journal_datalist_lock.  The
+ * caller provided us with a ref against the buffer, and we drop that here.
+ */
+static void release_buffer_page(struct buffer_head *bh)
+{
+	struct page *page;
+
+	if (buffer_dirty(bh))
+		goto nope;
+	if (atomic_read(&bh->b_count) != 1)
+		goto nope;
+	page = bh->b_page;
+	if (!page)
+		goto nope;
+	if (page->mapping)
+		goto nope;
+
+	/* OK, it's a truncated page */
+	if (TryLockPage(page))
+		goto nope;
+
+	page_cache_get(page);
+	__brelse(bh);
+	try_to_free_buffers(page, GFP_NOIO);
+	unlock_page(page);
+	page_cache_release(page);
+	return;
+
+nope:
+	__brelse(bh);
+}
+
+/*
  * journal_commit_transaction
  *
  * The primary function for committing a transaction to the log.  This
@@ -211,7 +256,7 @@
 				jh->b_transaction = NULL;
 				__journal_remove_journal_head(bh);
 				refile_buffer(bh);
-				__brelse(bh);
+				release_buffer_page(bh);
 			}
 		}
 		if (bufs == ARRAY_SIZE(wbuf)) {
@@ -648,7 +693,8 @@
 	while (commit_transaction->t_forget) {
 		transaction_t *cp_transaction;
 		struct buffer_head *bh;
-
+		int was_freed = 0;
+		
 		jh = commit_transaction->t_forget;
 		J_ASSERT_JH(jh,	jh->b_transaction == commit_transaction ||
 			jh->b_transaction == journal->j_running_transaction);
@@ -699,6 +745,7 @@
 		 * behind for writeback and gets reallocated for another
 		 * use in a different page. */
 		if (__buffer_state(bh, Freed)) {
+			was_freed = 1;
 			clear_bit(BH_Freed, &bh->b_state);
 			clear_bit(BH_JBDDirty, &bh->b_state);
 		}
@@ -714,7 +761,12 @@
 			__journal_unfile_buffer(jh);
 			jh->b_transaction = 0;
 			__journal_remove_journal_head(bh);
-			__brelse(bh);
+			spin_unlock(&journal_datalist_lock);
+			if (was_freed)
+				release_buffer_page(bh);
+			else
+				__brelse(bh);
+			continue;
 		}
 		spin_unlock(&journal_datalist_lock);
 	}
Index: fs/jbd/journal.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/jbd/journal.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/jbd/journal.c	22 Jul 2004 19:48:48 -0000	1.1
+++ fs/jbd/journal.c	4 Aug 2004 01:33:31 -0000	1.2
@@ -253,6 +253,7 @@
 
 		/* Were we woken up by a commit wakeup event? */
 		if ((transaction = journal->j_running_transaction) != NULL &&
+		    journal->j_commit_interval &&
 		    time_after_eq(jiffies, transaction->t_expires)) {
 			journal->j_commit_request = transaction->t_tid;
 			jbd_debug(1, "woke because of timeout\n");
@@ -670,6 +671,7 @@
 
 	bh = getblk(journal->j_dev, blocknr, journal->j_blocksize);
 	lock_buffer(bh);
+	memset(bh->b_data, 0, journal->j_blocksize);
 	BUFFER_TRACE(bh, "return this buffer");
 	return journal_add_journal_head(bh);
 }
@@ -705,7 +707,7 @@
 	init_MUTEX(&journal->j_checkpoint_sem);
 	init_MUTEX(&journal->j_sem);
 
-	journal->j_commit_interval = (HZ * 5);
+	journal->j_commit_interval = get_buffer_flushtime();
 
 	/* The journal is marked for error until we succeed with recovery! */
 	journal->j_flags = JFS_ABORT;
@@ -912,7 +914,7 @@
 		__brelse(bh);
 	}
 
-	sync_dev(journal->j_dev);
+	fsync_no_super(journal->j_dev);
 	jbd_debug(1, "JBD: journal cleared.\n");
 
 	/* OK, fill in the initial static fields in the new superblock */
Index: fs/jbd/transaction.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/jbd/transaction.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/jbd/transaction.c	22 Jul 2004 19:48:48 -0000	1.1
+++ fs/jbd/transaction.c	4 Aug 2004 01:33:31 -0000	1.2
@@ -59,11 +59,13 @@
 	transaction->t_expires = jiffies + journal->j_commit_interval;
 	INIT_LIST_HEAD(&transaction->t_jcb);
 
-	/* Set up the commit timer for the new transaction. */
-	J_ASSERT (!journal->j_commit_timer_active);
-	journal->j_commit_timer_active = 1;
-	journal->j_commit_timer->expires = transaction->t_expires;
-	add_timer(journal->j_commit_timer);
+	if (journal->j_commit_interval) {
+		/* Set up the commit timer for the new transaction. */
+		J_ASSERT (!journal->j_commit_timer_active);
+		journal->j_commit_timer_active = 1;
+		journal->j_commit_timer->expires = transaction->t_expires;
+		add_timer(journal->j_commit_timer);
+	}
 	
 	J_ASSERT (journal->j_running_transaction == NULL);
 	journal->j_running_transaction = transaction;
@@ -1465,7 +1467,8 @@
 	if (handle->h_sync ||
 			transaction->t_outstanding_credits >
 				journal->j_max_transaction_buffers ||
-	    		time_after_eq(jiffies, transaction->t_expires)) {
+	    		(journal->j_commit_interval &&
+	    		 time_after_eq(jiffies, transaction->t_expires))) {
 		/* Do this even for aborted journals: an abort still
 		 * completes the commit thread, it just doesn't write
 		 * anything to disk. */
@@ -1581,9 +1584,6 @@
 	assert_spin_locked(&journal_datalist_lock);
 	transaction = jh->b_transaction;
 
-#ifdef __SMP__
-	J_ASSERT (current->lock_depth >= 0);
-#endif
 	J_ASSERT_JH(jh, jh->b_jlist < BJ_Types);
 
 	if (jh->b_jlist != BJ_None)
@@ -2016,9 +2016,6 @@
 
 	assert_spin_locked(&journal_datalist_lock);
 	
-#ifdef __SMP__
-	J_ASSERT (current->lock_depth >= 0);
-#endif
 	J_ASSERT_JH(jh, jh->b_jlist < BJ_Types);
 	J_ASSERT_JH(jh, jh->b_transaction == transaction ||
 				jh->b_transaction == 0);
@@ -2108,9 +2105,6 @@
 	int was_dirty = 0;
 
 	assert_spin_locked(&journal_datalist_lock);
-#ifdef __SMP__
-	J_ASSERT_JH(jh, current->lock_depth >= 0);
-#endif
 	/* If the buffer is now unused, just drop it. */
 	if (jh->b_next_transaction == NULL) {
 		__journal_unfile_buffer(jh);
Index: fs/jffs/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/jffs/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/jffs/Makefile	22 Jul 2004 19:48:51 -0000	1.1
+++ fs/jffs/Makefile	4 Aug 2004 01:33:31 -0000	1.2
@@ -1,7 +1,7 @@
 #
 # Makefile for the linux Journalling Flash FileSystem (JFFS) routines.
 #
-# $Id: Makefile,v 1.1 2004/07/22 19:48:51 joff Exp $
+# $Id: Makefile,v 1.2 2004/08/04 01:33:31 joff Exp $
 #
 # Note! Dependencies are done automagically by 'make dep', which also
 # removes any old dependencies. DON'T put your own dependencies here
Index: fs/jffs/inode-v23.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/jffs/inode-v23.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/jffs/inode-v23.c	22 Jul 2004 19:48:51 -0000	1.1
+++ fs/jffs/inode-v23.c	4 Aug 2004 01:33:31 -0000	1.2
@@ -10,7 +10,7 @@
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- * $Id: inode-v23.c,v 1.1 2004/07/22 19:48:51 joff Exp $
+ * $Id: inode-v23.c,v 1.2 2004/08/04 01:33:31 joff Exp $
  *
  * Ported to Linux 2.3.x and MTD:
  * Copyright (C) 2000  Alexander Larsson (alex@cendio.se), Cendio Systems AB
Index: fs/jffs/intrep.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/jffs/intrep.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/jffs/intrep.c	22 Jul 2004 19:48:51 -0000	1.1
+++ fs/jffs/intrep.c	4 Aug 2004 01:33:31 -0000	1.2
@@ -10,7 +10,7 @@
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
- * $Id: intrep.c,v 1.1 2004/07/22 19:48:51 joff Exp $
+ * $Id: intrep.c,v 1.2 2004/08/04 01:33:31 joff Exp $
  *
  * Ported to Linux 2.3.x and MTD:
  * Copyright (C) 2000  Alexander Larsson (alex@cendio.se), Cendio Systems AB
@@ -3397,7 +3397,7 @@
 	init_completion(&c->gc_thread_comp); /* barrier */ 
 	spin_lock_irq(&current->sigmask_lock);
 	siginitsetinv (&current->blocked, sigmask(SIGHUP) | sigmask(SIGKILL) | sigmask(SIGSTOP) | sigmask(SIGCONT));
-	recalc_sigpending();
+	recalc_sigpending(current);
 	spin_unlock_irq(&current->sigmask_lock);
 	strcpy(current->comm, "jffs_gcd");
 
